
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>

#define DIM 1000000
int v[DIM];

// struttura che definisce i parametri della funzione sum
struct PAR
{
 int first_index;
 int last_index;
 int sum;
};

// funzione che implementa il codice dei thread
unsigned long WINAPI sum(void* arg)
{
 int i, s=0;

 struct PAR *par = (struct PAR*)(arg);
 
 for (i=par->first_index; i<=par->last_index; i++)
    s += v[i];
 
 par->sum = s;

 ExitThread(0);
}


void main(void)
{
 int i, v_sum;
 struct PAR par_1, par_2, par_3, par_4;
 HANDLE thread[4];

 // generazione casuale degli elementi del vettore
 for (i=0; i<DIM; i++)
    {
	 v[i] = rand()%1000;
    }

 // estremi della sezione di vettore assegnata al primo thread
 par_1.first_index = 0;
 par_1.last_index = DIM/4-1;

 // estremi della sezione di vettore assegnata al secondo thread
 par_2.first_index = DIM/4;
 par_2.last_index = DIM/2-1;

 // estremi della sezione di vettore assegnata al terzo thread
 par_3.first_index = DIM/2;
 par_3.last_index = DIM*3/4-1;

 // estremi della sezione di vettore assegnata al quarto thread
 par_4.first_index = DIM*3/4;
 par_4.last_index = DIM-1;

 // creazione dei thread e attesa della loro terminazione
 thread[0] = CreateThread(NULL,4096,&sum,&par_1,0,NULL);
 thread[1] = CreateThread(NULL,4096,&sum,&par_2,0,NULL);
 thread[2] = CreateThread(NULL,4096,&sum,&par_3,0,NULL);
 thread[3] = CreateThread(NULL,4096,&sum,&par_4,0,NULL);

 WaitForMultipleObjects(4,thread,1,INFINITE);
 
 v_sum = par_1.sum + par_2.sum + par_3.sum + par_4.sum;
 printf("Somma elementi = %i\r\n", v_sum);   
}
